



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>stackoverflow上关于iOS的票数最多（最常见）的15个问题</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">stackoverflow上关于iOS的票数最多（最常见）的15个问题</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-01 00:44:47 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><img referrerpolicy="no-referrer"src="http://mmbiz.qpic.cn/mmbiz/k0UVxv3BTLKwycVG3KG70YS7OXN2d5iabCON2N0eIAibvrp8qTlIjzMbT1pBgD8onyIpb8OU6EvcdwjNFZ1B9ibxw/640?wx_fmt=png&amp;wxfrom=5&amp;wx_lazy=1" data-src="http://mmbiz.qpic.cn/mmbiz/k0UVxv3BTLKwycVG3KG70YS7OXN2d5iabCON2N0eIAibvrp8qTlIjzMbT1pBgD8onyIpb8OU6EvcdwjNFZ1B9ibxw/0?wx_fmt=png" /></p>
<p>搞编程做项目的，没碰到bug、遇到问题，基本不可能。stackoverflow就是一个大型的开放的FAQ平台，你是问题制造者，也是答案提供者。本文列出至今stackoverflow上关于iOS的票数最高（最常见）的15个问题，仅为了大家能够更方便、直接、快速的找到自己想要的答案，也许其中某个（些）问题就是你已经碰到或者即将碰到的。</p>
<p>(这里的答案都是简单描述，有需要的话可以进入问题原页面查看详细答案)</p>
<p><strong>一、怎么把UILabel的内容竖直方向靠上排列</strong></p>
<p>我们都知道NSTextAlignment有五个值：</p>
<blockquote><p>NSTextAlignmentLeft; // 水平居左</p>
<p>NSTextAlignmentCenter; // 水平居中</p>
<p>NSTextAlignmentRight; // 水平居右</p>
<p>NSTextAlignmentJustified; // 合理铺满 等同于居左</p>
<p>NSTextAlignmentNatural; // 默认 等同于居左</p></blockquote>
<p>却没有想要的竖直方向居上或者居下:</p>
<blockquote><p>NSTextAlignmentTop;</p>
<p>NSTestAlignmentBottom;</p></blockquote>
<p>默认都是竖直居中的，怎么实现居上或者居下？</p>
<p>答：</p>
<p>UILabel不能设置竖直方向的排列布局，但是可以通过sizeToFit改变label的frame来实现曲线救国。</p>
<blockquote><p>Vertically align text to top within a UILabel</p>
<p>http://stackoverflow.com/questions/1054558/vertically-align-text-to-top-within-a-uilabel</p></blockquote>
<p><strong>二、atomic和nonatomic的区别是什么</strong></p>
<p>如下，atomic和nonatomic在声明成员变量时有什么作用：</p>
<blockquote><p>@property(nonatomic, retain) UITextField *userName;</p>
<p>@property(atomic, retain) UITextField *userName;</p>
<p>@property(retain) UITextField *userName;</p></blockquote>
<p>答：</p>
<p>有了atomic，合成的setter/getter（非自己重写的）可以经常返回一个完整的值（来自getter或者setter），即便其他线程正在进行setter活动，nonatomic没有这个保证。但是atomic并不能保证线程安全，所以为了运行速度和用户体验，一般用nonatomic，系统默认atomic。</p>
<blockquote><p>What&rsquo;s the difference between the atomic and nonatomic attributes?</p>
<p>http://stackoverflow.com/questions/588866/whats-the-difference-between-the-atomic-and-nonatomic-attributes</p></blockquote>
<p><strong>三、怎么让UITextField在弹出键盘时向上移动</strong></p>
<p>比如一些填写信息的页面，有些UITextField位置比较靠下，键盘弹出后会把它遮住，导致看不见输入的内容。</p>
<p>答：</p>
<p>通过监听键盘的状态移动UITextField所在的view。</p>
<blockquote><p>How to make a UITextField move up when keyboard is present?</p>
<p>http://stackoverflow.com/questions/1126726/how-to-make-a-uitextfield-move-up-when-keyboard-is-present</p></blockquote>
<p><strong>四、怎么检查iOS或者OS X设备的网络连接状态</strong></p>
<p>答：</p>
<p>借助于开源框架tonymillion/Reachability</p>
<blockquote><p>How to check for an active Internet connection on iOS or OSX?</p>
<p>http://stackoverflow.com/questions/1083701/how-to-check-for-an-active-internet-connection-on-ios-or-osx</p></blockquote>
<p><strong>五、performSelector：方法将会因为不知道它的选择器而导致内存泄露</strong></p>
<p>代码：</p>
<blockquote><p>[_controller performSelector:NSSelectorFromString(@"someMethod")];</p></blockquote>
<p>ARC编译器对上一行代码给出了一个警告：</p>
<blockquote><p>"performSelector may cause a leak because its selector is unknown".</p></blockquote>
<p>答：</p>
<p>利用IMP和函数指针方法配合解决。</p>
<blockquote><p>performSelector may cause a leak because its selector is unknown</p>
<p>http://stackoverflow.com/questions/7017281/performselector-may-cause-a-leak-because-its-selector-is-unknown</p></blockquote>
<p><strong>六、在Objective-C中怎么检查一个字符串中是否还有另外一个字符串</strong></p>
<p>答：</p>
<p>iOS8或OS X Yosemite之后：</p>
<blockquote><p>- (BOOL)containsString:(NSString *)str NS_AVAILABLE(10_10, 8_0);</p></blockquote>
<p>之前：</p>
<blockquote><p>NSString *string = @"hello bla bla";</p>
<p>if ([string rangeOfString:@"bla"].location == NSNotFound) {</p>
<p>NSLog(@"string does not contain bla");</p>
<p>} else {</p>
<p>NSLog(@"string contains bla!");</p>
<p>}</p></blockquote>
<blockquote><p>How do I check if a string contains another string in Objective-C?</p>
<p>http://stackoverflow.com/questions/2753956/how-do-i-check-if-a-string-contains-another-string-in-objective-c</p></blockquote>
<p><strong>七、如何对一个包含自定义对象的可变数组进行排序</strong></p>
<p>答：</p>
<blockquote><p>sortedArrayUsingComparator:</p></blockquote>
<blockquote><p>How to sort an NSMutableArray with custom objects in it?</p>
<p>http://stackoverflow.com/questions/805547/how-to-sort-an-nsmutablearray-with-custom-objects-in-it</p></blockquote>
<p><strong>八、用自动布局在tableView中给动态的cell布局和自适应高度</strong></p>
<p>答：</p>
<p>1、添加约束</p>
<p>2、确定cell的唯一的标识符</p>
<p>3、使用row的估计高度（iOS8）</p>
<p>4、添加高度缓存（需要的话）</p>
<blockquote><p>Using Auto Layout in UITableView for dynamic cell layouts &amp; variable row heights</p>
<p>http://stackoverflow.com/questions/18746929/using-auto-layout-in-uitableview-for-dynamic-cell-layouts-variable-row-heights</p></blockquote>
<p><strong>九、控制器之间的传值</strong></p>
<p>答：</p>
<p>属性、代理、block&hellip;</p>
<blockquote><p>Passing Data between View Controllers</p>
<p>http://stackoverflow.com/questions/5210535/passing-data-between-view-controllers</p></blockquote>
<p><strong>十、怎么用windows设备开发iPhone软件</strong></p>
<p>注：这个问题七年了，至今未有答案被采纳</p>
<blockquote><p>How can I develop for iPhone using a Windows development machine?</p>
<p>http://stackoverflow.com/questions/22358/how-can-i-develop-for-iphone-using-a-windows-development-machine</p></blockquote>
<p><strong>十一、怎么让tableView的cell选中时的高亮状态失效</strong></p>
<p>答：</p>
<blockquote><p>cell.selectionStyle = UITableViewCellSelectionStyleNone;</p></blockquote>
<blockquote><p>How can I disable the UITableView selection highlighting?</p>
<p>http://stackoverflow.com/questions/190908/how-can-i-disable-the-uitableview-selection-highlighting</p></blockquote>
<p><strong>十二、怎么在iOS7上改变状态栏的颜色</strong></p>
<p>答：</p>
<p>1、在.plist文件里把UIViewControllerBasedStatusBarAppearance设为YES。</p>
<p>2、在viewDidLoad添加[self setNeedsStatusBarAppearanceUpdate]..</p>
<p>3、在控制里添加如下代码:</p>
<blockquote><p>- (UIStatusBarStyle)preferredStatusBarStyle</p>
<p>{</p>
<p>return UIStatusBarStyleLightContent;</p>
<p>}</p></blockquote>
<blockquote><p>How to change Status Bar text color in iOS 7</p>
<p>http://stackoverflow.com/questions/17678881/how-to-change-status-bar-text-color-in-ios-7</p></blockquote>
<p><strong>十三、怎么改变iOS app的名字</strong></p>
<p>注：被采纳的答案是08年的，已不准确，可以点进去看详细答案。</p>
<blockquote><p>How to change the name of an iOS app?</p>
<p>http://stackoverflow.com/questions/238980/how-to-change-the-name-of-an-ios-app</p></blockquote>
<p><strong>十四、Xcode7报错&ldquo;iOS发布证书丢失&rdquo;</strong></p>
<p>打包上传AppStore时报如下错误：</p>
<blockquote><p>Failed to locate or generate matching signing assets</p>
<p>Xcode attempted to locate or generate matching signing assets and failed to do so because of the following issues.</p>
<p>Missing iOS Distribution signing identity for ... Xcode can request one for you.</p></blockquote>
<p>答：</p>
<p>首先、下载安装WWDR中级证书，</p>
<p>其次、在钥匙链访问应用中选取系统钥匙串&hellip;</p>
<blockquote><p>Xcode 7 error: &ldquo;Missing iOS Distribution signing identity for &hellip;&rdquo;</p>
<p>http://stackoverflow.com/questions/32821189/xcode-7-error-missing-ios-distribution-signing-identity-for</p></blockquote>
<p><strong>十五、传输安全阻止明文HTTP</strong></p>
<p>错误信息：</p>
<blockquote><p>Transport security has blocked a cleartext HTTP (http://) resource load since it is insecure. Temporary exceptions can be configured via your app's Info.plist file.</p></blockquote>
<p>答：</p>
<p>在工程info下面的配置里把Allow Arbitrary Loads设为YES。然后在Exception Domians下面添加要连接的主域名。</p>
<blockquote><p>Transport Security has Blocked a cleartext HTTP</p>
<p>http://stackoverflow.com/questions/31254725/transport-security-has-blocked-a-cleartext-http</p></blockquote>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/39r5z27q.html">使用--gc-section编译选项减小程序体积</a>
		</li>
						<li><a href="https://www.batexi.com/a/390rxjm9.html">XML文件解析并利用SimpleAdapter将解析结果显示在Activity中</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qx25408.html">SQL SERVER修改排序规则&amp;mdash&semi;&amp;mdash&semi;脚本篇</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8zr7znq.html">next&lpar;&lbrack;expr&rsqb;&rpar; 取得一个包含匹配的元素集合中每一个元素紧邻的后面同辈元素的元素集合。</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9p7rxy9.html">&lbrack;ZigBee&rsqb; 5、ZigBee基础实验&mdash;&mdash;图文与代码详解定时器1（16位定时器）（长文）</a>
		</li>
						<li><a href="https://www.batexi.com/a/495emoe9.html">HttpURLConnection下载图片的两种方式</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kyk169.html">MVC5 &plus; EF6 &plus; Bootstrap3 &lpar;7&rpar; Bootstrap的栅格系统</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjwxx49.html">java ScriptEngine 使用 （支持JavaScript脚本，eval&lpar;&rpar;函数等）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4yplw0q.html">51nod 1109 01组成的N的倍数</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e15gom9.html">Decode放在where条件后的新用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn14ryk8.html">CF 319B Psychos in a Line 【单调队列】</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydoxedq.html">nodejs  js模块加载</a>
		</li>
						<li><a href="https://www.batexi.com/a/96ow2yj9.html">&lbrack;转&rsqb; 多线程下变量-gcc原子操作 &lowbar;&lowbar;sync&lowbar;fetch&lowbar;and&lowbar;add等</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1wwm59.html">HTML5 canvas易错点</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rg5ddm8.html">解决：&amp;amp&semi;lt&semi;net&period;sf&period;ehcache&period;util&period;UpdateChecker&amp;amp&semi;gt&semi; &colon; New update&lpar;s&rpar; found&colon; 2&period;6&period;5</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mevvd0q.html">OpenStack&lowbar;I版 6&period;Neutron部署</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljdrm69.html">hdu2062 Subset sequence----递推</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eylyee9.html">javascript语法之for-in语句</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxk3m7e8.html">【视频】ASP&period;NET Core MVC 2&period;&ast; 入门</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rpxo68.html">oracle&period;sql&period;Clob类型转换成String类型</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9pjy6jy9.html">关于MATLAB中的tic toc的问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/qn1kzzg8.html">Service知识点总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/93xl4yw9.html">行为树实现AI逻辑</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j0ro7eq.html">栈的实现&lpar;JAVA&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gm0oje9.html">&bsol;u202e</a>
			</li>
						<li><a href="https://www.batexi.com/a/90vn6rj8.html">♫【MV&ast;】</a>
			</li>
						<li><a href="https://www.batexi.com/a/qydlzemq.html">Away3D基础之摄像机</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwde1wl8.html">nini</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlm2gyx9.html">OracleHelper&lbrack;&period;Net 连接Oracle数据库的封装类&rsqb;</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7mwpneq.html">C&num;开发移动平台iOS、Android 与Windows</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
